package org.tango.console.TestClient;

import java.util.Date;

import fr.esrf.Tango.DevError;
import fr.esrf.Tango.DevFailed;
import fr.esrf.TangoApi.CallBack;
import fr.esrf.TangoApi.events.EventData;

public class EvtCallBack extends CallBack 
{
	public void push_event(EventData evt)
	{
		Date date = new Date();
		System.out.println(date.toString());
		System.out.println("Event Name: " + evt.name);
		System.out.println("Event: " + evt.event);
		System.out.println("Event Type: " + evt.event_type);
		System.out.println("Event Source: " + evt.event_source);
		System.out.println("Event Error: " + evt.err);
		if(!evt.err)
		{
			try 
			{
				System.out.println("Attribute Value: " + evt.attr_value.extractDouble());
			}
			catch (DevFailed e) 
			{
				printErrors(e.errors);
			}
		}
		else
			printErrors(evt.errors);
		System.out.println("\n\n--------------------------------------------------------------------\n\n");
	}
	
	public void printErrors(DevError[] errs)
	{
		System.out.println("Error list size: " + errs.length);
		for(int i = 0; i < errs.length; i++)
		{
			System.out.println("Error " + (i + 1) + " Description: " + errs[i].desc);
			System.out.println("Error " + (i + 1) + " Severity: " + errs[i].severity.toString());
			System.out.println("Error " + (i + 1) + " Reason: " + errs[i].reason);
			System.out.println("Error " + (i + 1) + " Origin: " + errs[i].origin);
		}
	}
}
